package com.hxhq.business.service.impl;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hxhq.business.domain.StudyFormPlanJcgj;
import com.hxhq.business.utils.JctUtil;
import com.hxhq.business.utils.lang.StudyFormUtil;
import com.hxhq.common.core.exception.ServiceException;
import com.hxhq.common.core.utils.StringUtils;
import com.hxhq.system.api.domain.SysUser;
import org.springframework.stereotype.Service;
import com.hxhq.business.mapper.StudyFormPlanJcgjMapper;
import com.hxhq.business.service.IStudyFormPlanJcgjService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * 试验-计划单-稽查轨迹Service业务层处理
 *
 * @author hxhq
 * @date 2026-01-02
 */
@Service
public class StudyFormPlanJcgjServiceImpl extends ServiceImpl<StudyFormPlanJcgjMapper, StudyFormPlanJcgj> implements IStudyFormPlanJcgjService
{
    

    /**
     * 查询稽查轨迹列表
     * @param studyFormPlanJcgj
     * @return
     */
    @Override
    public List<StudyFormPlanJcgj> queryList(StudyFormPlanJcgj studyFormPlanJcgj){
        QueryWrapper<StudyFormPlanJcgj> queryWrapper = Wrappers.query();
        if(studyFormPlanJcgj.getFormId()==null||studyFormPlanJcgj.getFormId().longValue()<0){
            throw new ServiceException("表单id不能为空");
        }
        queryWrapper.eq("form_id",studyFormPlanJcgj.getFormId());
        if(studyFormPlanJcgj.getJcgjlx()!=null&&studyFormPlanJcgj.getJcgjlx().intValue()>0){
            queryWrapper.eq("jcgjlx",studyFormPlanJcgj.getJcgjlx());
        }
        if (StringUtils.isNoneBlank(studyFormPlanJcgj.getJcmc())) {
            queryWrapper.and(p -> p.like("`jcmc`", studyFormPlanJcgj.getJcmc())
                    .or().like("`jcnr`", studyFormPlanJcgj.getJcmc()));
        }
        queryWrapper.orderByDesc("id");
        return this.list(queryWrapper);
    }

    /**
     * 新增稽查轨迹
     * @param formId 表单id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     * @param time 时间
     */
    @Override
    public  void saveJcgj(Long  formId, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark, Date time){
        StudyFormPlanJcgj formJcgj = new StudyFormPlanJcgj();
        formJcgj.setFormId(formId);
        formJcgj.setJcgjlx(jcgjlx);
        formJcgj.setJcmc(jcmc);
        formJcgj.setJcmcEn(StudyFormUtil.getEn(jcmc));
        formJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            formJcgj.setJcnr(JctUtil.formatStr(jcnr));
            formJcgj.setJcnrEn(StudyFormUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null){
            formJcgj.setQmrId(qmr.getUserId());
            formJcgj.setQmrMc(qmr.getNickName());
            formJcgj.setQmrMcEn(qmr.getUserName());
        }
        if(time!=null){
            formJcgj.setCreateTime(time);
        }
        formJcgj.setRemark(remark);
        this.save(formJcgj);
    }


    /**
     * 新增稽查轨迹
     * @param formId 表单id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public StudyFormPlanJcgj getJcgj(Long  formId, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark){
        StudyFormPlanJcgj formJcgj = new StudyFormPlanJcgj();
        formJcgj.setFormId(formId);
        formJcgj.setJcgjlx(jcgjlx);
        formJcgj.setJcmc(jcmc);
        formJcgj.setJcmcEn(StudyFormUtil.getEn(jcmc));
        formJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            formJcgj.setJcnr(JctUtil.formatStr(jcnr));
            formJcgj.setJcnrEn(StudyFormUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null) {
            formJcgj.setQmrId(qmr.getUserId());
            formJcgj.setQmrMc(qmr.getNickName());
            formJcgj.setQmrMcEn(qmr.getUserName());
        }
        formJcgj.setRemark(remark);
        return  formJcgj;
    }

    /**
     * 新增稽查轨迹
     * @param formId 表单id
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param jcnrEn 稽查内容英文
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  StudyFormPlanJcgj getJcgj(Long  formId, Integer jcgjlx, String jcmc, Integer jcmcys, String jcnr,String jcnrEn, SysUser qmr, String remark){
        StudyFormPlanJcgj formJcgj = new StudyFormPlanJcgj();
        formJcgj.setFormId(formId);
        formJcgj.setJcgjlx(jcgjlx);
        formJcgj.setJcmc(jcmc);
        formJcgj.setJcmcEn(StudyFormUtil.getEn(jcmc));
        formJcgj.setJcmcys(jcmcys);
        formJcgj.setJcnr(jcnr);
        formJcgj.setJcnrEn(jcnrEn);
        if(qmr!=null) {
            formJcgj.setQmrId(qmr.getUserId());
            formJcgj.setQmrMc(qmr.getNickName());
            formJcgj.setQmrMcEn(qmr.getUserName());
        }
        formJcgj.setRemark(remark);
        return  formJcgj;
    }
}
